/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse sparql_parser_parse
#define yylex   sparql_parser_lex
#define yyerror sparql_parser_error
#define yylval  sparql_parser_lval
#define yychar  sparql_parser_char
#define yydebug sparql_parser_debug
#define yynerrs sparql_parser_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SELECT = 258,
     SOURCE = 259,
     FROM = 260,
     WHERE = 261,
     AND = 262,
     OPTIONAL = 263,
     PREFIX = 264,
     DESCRIBE = 265,
     CONSTRUCT = 266,
     ASK = 267,
     NOT = 268,
     DISTINCT = 269,
     LIMIT = 270,
     UNION = 271,
     BASE = 272,
     LOAD = 273,
     BOUND = 274,
     STR = 275,
     LANG = 276,
     DATATYPE = 277,
     ISURI = 278,
     ISBLANK = 279,
     ISLITERAL = 280,
     SC_AND = 281,
     SC_OR = 282,
     STR_NMATCH = 283,
     STR_MATCH = 284,
     STR_NE = 285,
     STR_EQ = 286,
     GE = 287,
     LE = 288,
     GT = 289,
     LT = 290,
     NEQ = 291,
     EQ = 292,
     FLOATING_POINT_LITERAL = 293,
     STRING_LITERAL = 294,
     PATTERN_LITERAL = 295,
     INTEGER_LITERAL = 296,
     BOOLEAN_LITERAL = 297,
     NULL_LITERAL = 298,
     URI_LITERAL = 299,
     QNAME_LITERAL = 300,
     BLANK_LITERAL = 301,
     IDENTIFIER = 302
   };
#endif
#define SELECT 258
#define SOURCE 259
#define FROM 260
#define WHERE 261
#define AND 262
#define OPTIONAL 263
#define PREFIX 264
#define DESCRIBE 265
#define CONSTRUCT 266
#define ASK 267
#define NOT 268
#define DISTINCT 269
#define LIMIT 270
#define UNION 271
#define BASE 272
#define LOAD 273
#define BOUND 274
#define STR 275
#define LANG 276
#define DATATYPE 277
#define ISURI 278
#define ISBLANK 279
#define ISLITERAL 280
#define SC_AND 281
#define SC_OR 282
#define STR_NMATCH 283
#define STR_MATCH 284
#define STR_NE 285
#define STR_EQ 286
#define GE 287
#define LE 288
#define GT 289
#define LT 290
#define NEQ 291
#define EQ 292
#define FLOATING_POINT_LITERAL 293
#define STRING_LITERAL 294
#define PATTERN_LITERAL 295
#define INTEGER_LITERAL 296
#define BOOLEAN_LITERAL 297
#define NULL_LITERAL 298
#define URI_LITERAL 299
#define QNAME_LITERAL 300
#define BLANK_LITERAL 301
#define IDENTIFIER 302




/* Copy the first part of user declarations.  */
#line 33 "./sparql_parser.y"

#ifdef HAVE_CONFIG_H
#include <rasqal_config.h>
#endif

#ifdef WIN32
#include <win32_rasqal_config.h>
#endif

#include <stdio.h>
#include <stdarg.h>

#include <rasqal.h>
#include <rasqal_internal.h>

#include <sparql_parser.h>

#define YY_DECL int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t yyscanner)
#include <sparql_lexer.h>

#include <sparql_common.h>


/* Make verbose error messages for syntax errors */
/*
#ifdef RASQAL_DEBUG
#define YYERROR_VERBOSE 1
#endif
*/
#define YYERROR_VERBOSE 1

/* Slow down the grammar operation and watch it work */
#if RASQAL_DEBUG > 2
#define YYDEBUG 1
#endif

/* the lexer does not seem to track this */
#undef RASQAL_SPARQL_USE_ERROR_COLUMNS

/* Missing sparql_lexer.c/h prototypes */
int sparql_lexer_get_column(yyscan_t yyscanner);
/* Not used here */
/* void sparql_lexer_set_column(int  column_no , yyscan_t yyscanner);*/


/* What the lexer wants */
extern int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t scanner);
#define YYLEX_PARAM ((rasqal_sparql_query_engine*)(((rasqal_query*)rq)->context))->scanner

/* Pure parser argument (a void*) */
#define YYPARSE_PARAM rq

/* Make the yyerror below use the rdf_parser */
#undef yyerror
#define yyerror(message) sparql_query_error((rasqal_query*)rq, message)

/* Make lex/yacc interface as small as possible */
#undef yylex
#define yylex sparql_lexer_lex


static int sparql_parse(rasqal_query* rq, const unsigned char *string);
static void sparql_query_error(rasqal_query* rq, const char *message);
static void sparql_query_error_full(rasqal_query *rq, const char *message, ...);


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 107 "./sparql_parser.y"
typedef union YYSTYPE {
  raptor_sequence *seq;
  rasqal_variable *variable;
  rasqal_literal *literal;
  rasqal_triple *triple;
  rasqal_expression *expr;
  rasqal_graph_pattern *graph_pattern;
  double floating;
  raptor_uri *uri;
  unsigned char *name;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 257 "sparql_parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 269 "sparql_parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   298

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  43
/* YYNRULES -- Number of rules. */
#define YYNRULES  121
/* YYNRULES -- Number of states. */
#define YYNSTATES  204

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   302

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    54,     2,     2,    34,    52,    35,     2,
      27,    28,    50,    48,    26,    49,     2,    51,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    33,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    29,     2,    30,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,    32,    53,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,    11,    13,    15,    17,    19,    23,    27,
      30,    33,    36,    39,    42,    45,    47,    50,    51,    54,
      55,    58,    59,    62,    63,    66,    68,    70,    74,    76,
      78,    82,    84,    88,    92,    95,    99,   102,   105,   107,
     113,   116,   118,   124,   127,   131,   134,   138,   140,   142,
     145,   149,   151,   154,   158,   159,   161,   163,   165,   167,
     169,   171,   173,   175,   178,   179,   184,   185,   189,   191,
     195,   197,   201,   205,   209,   213,   215,   219,   223,   225,
     229,   233,   237,   241,   243,   247,   251,   253,   257,   261,
     265,   267,   270,   273,   275,   280,   285,   290,   295,   300,
     305,   310,   312,   315,   318,   320,   322,   328,   332,   335,
     336,   338,   340,   342,   344,   346,   348,   350,   352,   354,
     357,   360
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      66,     0,    -1,    91,    92,    67,    72,    73,    74,    75,
      -1,    68,    -1,    70,    -1,    69,    -1,    71,    -1,     3,
      14,    85,    -1,     3,    14,    50,    -1,     3,    85,    -1,
       3,    50,    -1,    10,    84,    -1,    10,    50,    -1,    11,
      82,    -1,    11,    50,    -1,    12,    -1,    18,    86,    -1,
      -1,     5,    86,    -1,    -1,     6,    76,    -1,    -1,    15,
      58,    -1,    -1,    76,    77,    -1,    77,    -1,    80,    -1,
      31,    76,    32,    -1,    79,    -1,    81,    -1,    31,    76,
      32,    -1,    79,    -1,     4,    50,    78,    -1,     4,    87,
      78,    -1,     8,    78,    -1,    29,    76,    30,    -1,     7,
      93,    -1,    80,    81,    -1,    81,    -1,    27,    87,    87,
      88,    28,    -1,    82,    83,    -1,    83,    -1,    27,    89,
      87,    90,    28,    -1,    84,   106,    -1,    84,    26,   106,
      -1,    84,   105,    -1,    84,    26,   105,    -1,   106,    -1,
     105,    -1,    85,   106,    -1,    85,    26,   106,    -1,   106,
      -1,    86,   105,    -1,    86,    26,   105,    -1,    -1,   106,
      -1,   105,    -1,   106,    -1,   104,    -1,    87,    -1,   107,
      -1,    88,    -1,   107,    -1,    17,    61,    -1,    -1,    92,
       9,    64,    61,    -1,    -1,    94,    37,    93,    -1,    94,
      -1,    95,    36,    94,    -1,    95,    -1,    96,    41,    96,
      -1,    96,    40,    96,    -1,    96,    39,    57,    -1,    96,
      38,    57,    -1,    96,    -1,    97,    47,    97,    -1,    97,
      46,    97,    -1,    97,    -1,    98,    45,    98,    -1,    98,
      44,    98,    -1,    98,    43,    98,    -1,    98,    42,    98,
      -1,    98,    -1,    99,    48,    98,    -1,    99,    49,    98,
      -1,    99,    -1,   100,    50,    99,    -1,   100,    51,    99,
      -1,   100,    52,    99,    -1,   100,    -1,    48,   101,    -1,
      49,   101,    -1,   101,    -1,    19,    27,   106,    28,    -1,
      20,    27,    88,    28,    -1,    21,    27,    88,    28,    -1,
      22,    27,    88,    28,    -1,    23,    27,    88,    28,    -1,
      24,    27,    88,    28,    -1,    25,    27,    88,    28,    -1,
     102,    -1,    53,   100,    -1,    54,   100,    -1,   106,    -1,
     104,    -1,    35,    62,    27,   103,    28,    -1,    27,    93,
      28,    -1,   103,    88,    -1,    -1,    61,    -1,    58,    -1,
      55,    -1,    56,    -1,    59,    -1,    60,    -1,    62,    -1,
      61,    -1,    62,    -1,    33,    64,    -1,    34,    64,    -1,
      63,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   197,   197,   204,   208,   212,   217,   227,   232,   238,
     242,   251,   255,   262,   266,   275,   281,   286,   292,   300,
     308,   316,   322,   327,   341,   358,   377,   397,   407,   424,
     444,   454,   472,   484,   507,   528,   551,   569,   574,   583,
     591,   596,   605,   613,   618,   623,   628,   633,   639,   647,
     652,   657,   666,   674,   683,   690,   694,   701,   705,   713,
     717,   724,   728,   736,   743,   750,   758,   765,   769,   778,
     783,   790,   794,   798,   802,   806,   817,   821,   825,   834,
     838,   842,   846,   850,   859,   863,   867,   877,   881,   885,
     889,   898,   902,   906,   913,   919,   924,   929,   934,   939,
     944,   949,   957,   961,   965,   970,   974,   981,   992,   998,
    1005,  1009,  1013,  1017,  1021,  1025,  1028,  1047,  1051,  1070,
    1074,  1082
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SELECT", "SOURCE", "FROM", "WHERE",
  "AND", "OPTIONAL", "PREFIX", "DESCRIBE", "CONSTRUCT", "ASK", "NOT",
  "DISTINCT", "LIMIT", "UNION", "BASE", "LOAD", "BOUND", "STR", "LANG",
  "DATATYPE", "ISURI", "ISBLANK", "ISLITERAL", "','", "'('", "')'", "'['",
  "']'", "'{'", "'}'", "'?'", "'$'", "'&'", "SC_AND", "SC_OR",
  "STR_NMATCH", "STR_MATCH", "STR_NE", "STR_EQ", "GE", "LE", "GT", "LT",
  "NEQ", "EQ", "'+'", "'-'", "'*'", "'/'", "'%'", "'~'", "'!'",
  "FLOATING_POINT_LITERAL", "STRING_LITERAL", "PATTERN_LITERAL",
  "INTEGER_LITERAL", "BOOLEAN_LITERAL", "NULL_LITERAL", "URI_LITERAL",
  "QNAME_LITERAL", "BLANK_LITERAL", "IDENTIFIER", "$accept", "Query",
  "ReportFormat", "SelectClause", "DescribeClause", "ConstructClause",
  "AskClause", "LoadClauseOpt", "FromClauseOpt", "WhereClauseOpt",
  "LimitClauseOpt", "GraphPattern", "PatternElement", "GraphPattern1",
  "PatternElementForms", "TriplePatternList", "TriplePattern",
  "ConstructPattern", "TripleTemplate", "VarOrURIList", "VarList",
  "URIList", "VarOrURI", "VarOrLiteral", "VarOrURIOrBNode",
  "VarOrLiteralOrBNode", "BaseDeclOpt", "PrefixDeclOpt", "Expression",
  "ConditionalAndExpression", "ValueLogical", "EqualityExpression",
  "RelationalExpression", "AdditiveExpression", "MultiplicativeExpression",
  "UnaryExpression", "BuiltinExpression", "UnaryExpressionNotPlusMinus",
  "ArgList", "Literal", "URI", "Var", "BNode", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    44,    40,    41,    91,
      93,   123,   125,    63,    36,    38,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    43,    45,
      42,    47,    37,   126,    33,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    65,    66,    67,    67,    67,    67,    68,    68,    68,
      68,    69,    69,    70,    70,    71,    72,    72,    73,    73,
      74,    74,    75,    75,    76,    76,    77,    77,    77,    78,
      78,    78,    79,    79,    79,    79,    79,    80,    80,    81,
      82,    82,    83,    84,    84,    84,    84,    84,    84,    85,
      85,    85,    86,    86,    86,    87,    87,    88,    88,    89,
      89,    90,    90,    91,    91,    92,    92,    93,    93,    94,
      94,    95,    95,    95,    95,    95,    96,    96,    96,    97,
      97,    97,    97,    97,    98,    98,    98,    99,    99,    99,
      99,   100,   100,   100,   101,   101,   101,   101,   101,   101,
     101,   101,   102,   102,   102,   102,   102,   102,   103,   103,
     104,   104,   104,   104,   104,   104,   104,   105,   105,   106,
     106,   107
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     7,     1,     1,     1,     1,     3,     3,     2,
       2,     2,     2,     2,     2,     1,     2,     0,     2,     0,
       2,     0,     2,     0,     2,     1,     1,     3,     1,     1,
       3,     1,     3,     3,     2,     3,     2,     2,     1,     5,
       2,     1,     5,     2,     3,     2,     3,     1,     1,     2,
       3,     1,     2,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     0,     4,     0,     3,     1,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       1,     2,     2,     1,     4,     4,     4,     4,     4,     4,
       4,     1,     2,     2,     1,     1,     5,     3,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      64,     0,     0,    66,    63,     1,     0,     0,     0,     0,
       0,    15,    17,     3,     5,     4,     6,     0,     0,     0,
      10,     9,    51,     0,    12,   117,   118,    11,    48,    47,
       0,    14,    13,    41,    54,    19,     8,     7,   119,   120,
       0,    49,    65,     0,    45,    43,   121,    59,     0,    56,
      55,    60,    40,    16,    54,    21,    50,    46,    44,     0,
       0,    52,    18,     0,    23,   112,   113,   111,   114,   115,
     110,   116,    61,     0,    58,    57,    62,    53,     0,     0,
       0,     0,     0,     0,    20,    25,    28,    26,    38,     0,
       2,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    68,    70,
      75,    78,    83,    86,    90,    93,   101,   105,   104,     0,
      34,    31,    29,     0,     0,     0,    24,    37,    22,    32,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      91,    92,   102,   103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    35,    27,     0,     0,     0,     0,     0,
       0,     0,   107,   109,    67,    69,    74,    73,    72,    71,
      77,    76,    82,    81,    80,    79,    84,    85,    87,    88,
      89,    30,     0,    94,    95,    96,    97,    98,    99,   100,
       0,    39,   106,   108
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,    12,    13,    14,    15,    16,    35,    55,    64,
      90,    84,    85,   120,    86,    87,    88,    32,    33,    27,
      21,    53,    47,    72,    48,    73,     3,     6,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   200,   117,
      49,   118,    51
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -109
static const short yypact[] =
{
       0,   -40,    35,  -109,  -109,  -109,    53,    33,   -24,   163,
     -19,  -109,    57,  -109,  -109,  -109,  -109,   -18,   -11,     4,
    -109,   -15,  -109,    24,  -109,  -109,  -109,    25,  -109,  -109,
      27,  -109,    80,  -109,  -109,    86,  -109,   -15,  -109,  -109,
     -21,  -109,  -109,    79,  -109,  -109,  -109,  -109,    79,  -109,
    -109,  -109,  -109,     8,  -109,    87,  -109,  -109,  -109,    39,
      43,  -109,     8,   241,   108,  -109,  -109,  -109,  -109,  -109,
    -109,  -109,  -109,   110,  -109,  -109,  -109,  -109,   165,   112,
     267,    79,   241,   241,   241,  -109,  -109,   142,  -109,   128,
    -109,  -109,   267,   267,   177,   187,   191,   206,   212,   214,
     215,   112,   130,   129,   129,   112,   112,  -109,   213,   216,
     138,    64,   234,    66,   107,  -109,  -109,  -109,  -109,   241,
    -109,  -109,  -109,    79,   236,   224,  -109,  -109,  -109,  -109,
    -109,   -21,   161,   161,   161,   161,   161,   161,   226,   231,
    -109,  -109,  -109,  -109,   112,   112,   203,   207,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   230,   161,  -109,  -109,   245,   252,   253,   254,   255,
     256,   257,  -109,  -109,  -109,  -109,  -109,  -109,  -109,  -109,
    -109,  -109,  -109,  -109,  -109,  -109,  -109,  -109,  -109,  -109,
    -109,  -109,   258,  -109,  -109,  -109,  -109,  -109,  -109,  -109,
     147,  -109,  -109,  -109
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -109,  -109,  -109,  -109,  -109,  -109,  -109,  -109,  -109,  -109,
    -109,   -76,   -79,    50,   -43,  -109,    16,  -109,   237,  -109,
     270,   235,   -39,  -108,  -109,  -109,  -109,  -109,  -100,   145,
    -109,    81,    85,   -35,    52,    95,   143,  -109,  -109,   -56,
      -5,    -7,   229
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      22,   138,    29,    74,    28,   126,   124,   125,    30,    59,
      22,    40,    18,    19,    41,    18,    19,     1,    18,    19,
      45,     4,    44,    50,   166,   167,   168,   169,   170,   171,
      41,    31,    36,    56,    60,     5,    58,   121,    57,    93,
      23,    50,   123,   161,   174,   126,   126,    17,    61,   121,
     121,    43,    75,    38,   192,    77,     7,    61,    18,    19,
      18,    19,     8,     9,    10,    11,    18,    19,    39,    25,
      26,    50,    18,    19,    50,    34,    74,    74,    74,    74,
      74,    74,   126,    20,   162,    42,    25,    26,    25,    26,
      46,    54,   203,    63,    65,    66,   122,    67,    68,    69,
      70,    71,    46,   127,    25,    26,    74,    30,   122,   122,
     150,   151,    18,    19,   156,   157,    50,   182,   183,   184,
     185,   186,   187,    89,   165,    75,    75,    75,    75,    75,
      75,    94,    95,    96,    97,    98,    99,   100,    91,   101,
      25,    26,   129,   130,    74,    18,    19,   102,    94,    95,
      96,    97,    98,    99,   100,    75,   101,   158,   159,   160,
     103,   104,    18,    19,   102,   105,   106,    65,    66,    81,
      67,    68,    69,    70,    71,   202,   146,   147,   148,   149,
      18,    19,   105,   106,    65,    66,   128,    67,    68,    69,
      70,    71,   139,    75,    18,    19,    18,    19,    18,    19,
     142,   143,    65,    66,   131,    67,    68,    69,    70,    71,
     188,   189,   190,    24,   132,    92,    65,    66,   133,    67,
      68,    69,    70,    71,    25,    26,    25,    26,    78,   178,
     179,    79,    80,   134,    78,   180,   181,    79,    80,   135,
      78,   136,   137,    79,    80,    78,   140,   141,    79,    80,
     144,    81,   145,    82,   172,    83,   164,    81,   173,    82,
     176,    83,   191,    81,   177,    82,   163,    83,    81,    52,
      82,    78,    83,   193,    79,    80,   152,   153,   154,   155,
     194,   195,   196,   197,   198,   199,   201,    37,    76,    62,
     175,     0,     0,     0,    81,     0,    82,     0,   119
};

static const short yycheck[] =
{
       7,   101,     9,    59,     9,    84,    82,    83,    27,    48,
      17,    26,    33,    34,    21,    33,    34,    17,    33,    34,
      27,    61,    27,    30,   132,   133,   134,   135,   136,   137,
      37,    50,    50,    40,    26,     0,    43,    80,    43,    78,
      64,    48,    81,   119,   144,   124,   125,    14,    53,    92,
      93,    26,    59,    64,   162,    60,     3,    62,    33,    34,
      33,    34,     9,    10,    11,    12,    33,    34,    64,    61,
      62,    78,    33,    34,    81,    18,   132,   133,   134,   135,
     136,   137,   161,    50,   123,    61,    61,    62,    61,    62,
      63,     5,   200,     6,    55,    56,    80,    58,    59,    60,
      61,    62,    63,    87,    61,    62,   162,    27,    92,    93,
      46,    47,    33,    34,    48,    49,   123,   152,   153,   154,
     155,   156,   157,    15,   131,   132,   133,   134,   135,   136,
     137,    19,    20,    21,    22,    23,    24,    25,    28,    27,
      61,    62,    92,    93,   200,    33,    34,    35,    19,    20,
      21,    22,    23,    24,    25,   162,    27,    50,    51,    52,
      48,    49,    33,    34,    35,    53,    54,    55,    56,    27,
      58,    59,    60,    61,    62,    28,    38,    39,    40,    41,
      33,    34,    53,    54,    55,    56,    58,    58,    59,    60,
      61,    62,    62,   200,    33,    34,    33,    34,    33,    34,
     105,   106,    55,    56,    27,    58,    59,    60,    61,    62,
     158,   159,   160,    50,    27,    50,    55,    56,    27,    58,
      59,    60,    61,    62,    61,    62,    61,    62,     4,   148,
     149,     7,     8,    27,     4,   150,   151,     7,     8,    27,
       4,    27,    27,     7,     8,     4,   103,   104,     7,     8,
      37,    27,    36,    29,    28,    31,    32,    27,    27,    29,
      57,    31,    32,    27,    57,    29,    30,    31,    27,    32,
      29,     4,    31,    28,     7,     8,    42,    43,    44,    45,
      28,    28,    28,    28,    28,    28,    28,    17,    59,    54,
     145,    -1,    -1,    -1,    27,    -1,    29,    -1,    31
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    17,    66,    91,    61,     0,    92,     3,     9,    10,
      11,    12,    67,    68,    69,    70,    71,    14,    33,    34,
      50,    85,   106,    64,    50,    61,    62,    84,   105,   106,
      27,    50,    82,    83,    18,    72,    50,    85,    64,    64,
      26,   106,    61,    26,   105,   106,    63,    87,    89,   105,
     106,   107,    83,    86,     5,    73,   106,   105,   106,    87,
      26,   105,    86,     6,    74,    55,    56,    58,    59,    60,
      61,    62,    88,    90,   104,   106,   107,   105,     4,     7,
       8,    27,    29,    31,    76,    77,    79,    80,    81,    15,
      75,    28,    50,    87,    19,    20,    21,    22,    23,    24,
      25,    27,    35,    48,    49,    53,    54,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   104,   106,    31,
      78,    79,    81,    87,    76,    76,    77,    81,    58,    78,
      78,    27,    27,    27,    27,    27,    27,    27,    93,    62,
     101,   101,   100,   100,    37,    36,    38,    39,    40,    41,
      46,    47,    42,    43,    44,    45,    48,    49,    50,    51,
      52,    76,    87,    30,    32,   106,    88,    88,    88,    88,
      88,    88,    28,    27,    93,    94,    57,    57,    96,    96,
      97,    97,    98,    98,    98,    98,    98,    98,    99,    99,
      99,    32,    88,    28,    28,    28,    28,    28,    28,    28,
     103,    28,    28,    88
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 199 "./sparql_parser.y"
    {
}
    break;

  case 3:
#line 205 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->selects=yyvsp[0].seq;
}
    break;

  case 4:
#line 209 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->constructs=yyvsp[0].seq;
}
    break;

  case 5:
#line 213 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->select_is_describe=1;
  ((rasqal_query*)rq)->describes=yyvsp[0].seq;
}
    break;

  case 6:
#line 218 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->ask=1;
}
    break;

  case 7:
#line 228 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[0].seq;
  ((rasqal_query*)rq)->distinct=1;
}
    break;

  case 8:
#line 233 "./sparql_parser.y"
    {
  yyval.seq=NULL;
  ((rasqal_query*)rq)->select_all=1;
  ((rasqal_query*)rq)->distinct=1;
}
    break;

  case 9:
#line 239 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[0].seq;
}
    break;

  case 10:
#line 243 "./sparql_parser.y"
    {
  yyval.seq=NULL;
  ((rasqal_query*)rq)->select_all=1;
}
    break;

  case 11:
#line 252 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[0].seq;
}
    break;

  case 12:
#line 256 "./sparql_parser.y"
    {
  yyval.seq=NULL;
}
    break;

  case 13:
#line 263 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[0].seq;
}
    break;

  case 14:
#line 267 "./sparql_parser.y"
    {
  yyval.seq=NULL;
  ((rasqal_query*)rq)->construct_all=1;
}
    break;

  case 15:
#line 276 "./sparql_parser.y"
    {
}
    break;

  case 16:
#line 282 "./sparql_parser.y"
    {
  /* FIXME */
}
    break;

  case 17:
#line 286 "./sparql_parser.y"
    {
}
    break;

  case 18:
#line 293 "./sparql_parser.y"
    {
  if(yyvsp[0].seq) {
    raptor_sequence_join(((rasqal_query*)rq)->sources, yyvsp[0].seq);
    raptor_free_sequence(yyvsp[0].seq);
  }
}
    break;

  case 19:
#line 300 "./sparql_parser.y"
    {
}
    break;

  case 20:
#line 309 "./sparql_parser.y"
    {
  if(yyvsp[0].seq) {
    raptor_sequence_join(((rasqal_query*)rq)->graph_patterns, yyvsp[0].seq);
    raptor_free_sequence(yyvsp[0].seq);
  }
}
    break;

  case 21:
#line 316 "./sparql_parser.y"
    {
}
    break;

  case 22:
#line 323 "./sparql_parser.y"
    {
  /* FIXME */
}
    break;

  case 23:
#line 327 "./sparql_parser.y"
    {
}
    break;

  case 24:
#line 342 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("GraphPattern 1\n  graphpattern=");
  raptor_sequence_print(yyvsp[-1].seq, stdout);
  printf(", patternelement=");
  if(yyvsp[0].graph_pattern)
    rasqal_graph_pattern_print(yyvsp[0].graph_pattern, stdout);
  else
    fputs("NULL", stdout);
  fputs("\n\n", stdout);
#endif

  yyval.seq=yyvsp[-1].seq;
  if(yyvsp[0].graph_pattern)
    raptor_sequence_push(yyval.seq, yyvsp[0].graph_pattern);
}
    break;

  case 25:
#line 359 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("GraphPattern 2\n  patternelement=");
  if(yyvsp[0].graph_pattern)
    rasqal_graph_pattern_print(yyvsp[0].graph_pattern, stdout);
  else
    fputs("NULL", stdout);
  fputs("\n\n", stdout);
#endif

  yyval.seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern, (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
  if(yyvsp[0].graph_pattern)
    raptor_sequence_push(yyval.seq, yyvsp[0].graph_pattern);
}
    break;

  case 26:
#line 378 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("PatternElement 1\n  triplepatternlist=");
  raptor_sequence_print(yyvsp[0].seq, stdout);
  fputs("\n\n", stdout);
#endif
  
  if(yyvsp[0].seq) {
    raptor_sequence *s=((rasqal_query*)rq)->triples;
    int offset=raptor_sequence_size(s);
    int triple_pattern_size=raptor_sequence_size(yyvsp[0].seq);
    
    raptor_sequence_join(s, yyvsp[0].seq);
    raptor_free_sequence(yyvsp[0].seq);

    yyval.graph_pattern=rasqal_new_graph_pattern_from_triples((rasqal_query*)rq, s, offset, offset+triple_pattern_size-1, 0);
  } else
    yyval.graph_pattern=NULL;
}
    break;

  case 27:
#line 398 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("PatternElement 2\n  graphpattern=");
  raptor_sequence_print(yyvsp[-1].seq, stdout);
  fputs("\n\n", stdout);
#endif
  
  yyval.graph_pattern=rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq, yyvsp[-1].seq, 0);
}
    break;

  case 28:
#line 408 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("PatternElement 3\n  patternelementforms=");
  if(yyvsp[0].graph_pattern)
    rasqal_graph_pattern_print(yyvsp[0].graph_pattern, stdout);
  else
    fputs("NULL", stdout);
  fputs("\n\n", stdout);
#endif
  
  yyval.graph_pattern=yyvsp[0].graph_pattern;
}
    break;

  case 29:
#line 425 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("GraphPattern1 1\n  triplepattern=");
  if(yyvsp[0].triple)
    rasqal_triple_print(yyvsp[0].triple, stdout);
  else
    fputs("NULL", stdout);
  fputs("\n\n", stdout);
#endif

  if(yyvsp[0].triple) {
    raptor_sequence *s=((rasqal_query*)rq)->triples;
    int offset=raptor_sequence_size(s);
    raptor_sequence_push(s, yyvsp[0].triple);

    yyval.graph_pattern=rasqal_new_graph_pattern_from_triples((rasqal_query*)rq, s, offset, offset, 0);
  } else
    yyval.graph_pattern=NULL;
}
    break;

  case 30:
#line 445 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("GraphPattern1 2\n  triplepattern=");
  raptor_sequence_print(yyvsp[-1].seq, stdout);
  fputs("\n\n", stdout);
#endif

  yyval.graph_pattern=rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq, yyvsp[-1].seq, 0);
}
    break;

  case 31:
#line 455 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("PatternElement 3\n  patternelementforms=");
  rasqal_graph_pattern_print(yyvsp[0].graph_pattern, stdout);
  fputs("\n\n", stdout);
#endif
  
  yyval.graph_pattern=yyvsp[0].graph_pattern;
}
    break;

  case 32:
#line 473 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("PatternElementForms 1\n  graphpattern=");
  rasqal_graph_pattern_print(yyvsp[0].graph_pattern, stdout);
  fputs("\n\n", stdout);
#endif

  /* FIXME - SOURCE * has no defined meaning */
  sparql_syntax_warning(((rasqal_query*)rq), "SPARQL SOURCE * ignored");
  yyval.graph_pattern=yyvsp[0].graph_pattern;
}
    break;

  case 33:
#line 485 "./sparql_parser.y"
    {
  int i;
  raptor_sequence *s=yyvsp[0].graph_pattern->graph_patterns;
  
#if RASQAL_DEBUG > 1  
  printf("PatternElementForms 2\n  varoruri=");
  rasqal_literal_print(yyvsp[-1].literal, stdout);
  printf(", graphpattern=");
  rasqal_graph_pattern_print(yyvsp[0].graph_pattern, stdout);
  fputs("\n\n", stdout);
#endif

  if(s) {
    /* Flag all the triples in GraphPattern1 with origin $2 */
    for(i=0; i < raptor_sequence_size(s); i++) {
      rasqal_triple *t=(rasqal_triple*)raptor_sequence_get_at(s, i);
      rasqal_triple_set_origin(t, rasqal_new_literal_from_literal(yyvsp[-1].literal));
    }
  }
  rasqal_free_literal(yyvsp[-1].literal);
  yyval.graph_pattern=yyvsp[0].graph_pattern;
}
    break;

  case 34:
#line 508 "./sparql_parser.y"
    {
  int i;
  raptor_sequence *s=yyvsp[0].graph_pattern->graph_patterns;

#if RASQAL_DEBUG > 1  
  printf("PatternElementForms 3\n  graphpattern=");
  rasqal_graph_pattern_print(yyvsp[0].graph_pattern, stdout);
  fputs("\n\n", stdout);
#endif

  if(s) {
    /* Flag all the triples in GraphPattern1 as optional */
    for(i=0; i < raptor_sequence_size(s); i++) {
      rasqal_triple *t=(rasqal_triple*)raptor_sequence_get_at(s, i);
      t->flags |= RASQAL_TRIPLE_FLAGS_OPTIONAL;
    }
  }
  yyval.graph_pattern=yyvsp[0].graph_pattern;
  yyval.graph_pattern->flags |= RASQAL_PATTERN_FLAGS_OPTIONAL;
}
    break;

  case 35:
#line 529 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  printf("PatternElementForms 4\n  graphpattern=");
  if(yyvsp[-1].seq)
    raptor_sequence_print(yyvsp[-1].seq, stdout);
  else
    fputs("NULL", stdout);
  fputs("\n\n", stdout);
#endif

  if(yyvsp[-1].seq) {
    /* Make all graph patterns in GraphPattern, optional */
    for(i=0; i < raptor_sequence_size(yyvsp[-1].seq); i++) {
      rasqal_graph_pattern *gp=(rasqal_graph_pattern*)raptor_sequence_get_at(yyvsp[-1].seq, i);
      gp->flags |= RASQAL_PATTERN_FLAGS_OPTIONAL;
    }
    yyval.graph_pattern=rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq, yyvsp[-1].seq, RASQAL_PATTERN_FLAGS_OPTIONAL);
  } else
    yyval.graph_pattern=NULL;
}
    break;

  case 36:
#line 552 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  printf("PatternElementForms 4\n expression=");
  rasqal_expression_print(yyvsp[0].expr, stdout);
  fputs("\n\n", stdout);
#endif

  rasqal_query_add_constraint(((rasqal_query*)rq), yyvsp[0].expr);
  yyval.graph_pattern=NULL;
}
    break;

  case 37:
#line 570 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-1].seq;
  raptor_sequence_push(yyval.seq, yyvsp[0].triple);
}
    break;

  case 38:
#line 575 "./sparql_parser.y"
    {
  yyval.seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple, (raptor_sequence_print_handler*)rasqal_triple_print);
  raptor_sequence_push(yyval.seq, yyvsp[0].triple);
}
    break;

  case 39:
#line 584 "./sparql_parser.y"
    {
  yyval.triple=rasqal_new_triple(yyvsp[-3].literal, yyvsp[-2].literal, yyvsp[-1].literal);
}
    break;

  case 40:
#line 592 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-1].seq;
  raptor_sequence_push(yyval.seq, yyvsp[0].triple);
}
    break;

  case 41:
#line 597 "./sparql_parser.y"
    {
  yyval.seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple, (raptor_sequence_print_handler*)rasqal_triple_print);
  raptor_sequence_push(yyval.seq, yyvsp[0].triple);
}
    break;

  case 42:
#line 606 "./sparql_parser.y"
    {
  yyval.triple=rasqal_new_triple(yyvsp[-3].literal, yyvsp[-2].literal, yyvsp[-1].literal);
}
    break;

  case 43:
#line 614 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-1].seq;
  raptor_sequence_push(yyval.seq, rasqal_new_variable_literal(yyvsp[0].variable));
}
    break;

  case 44:
#line 619 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-2].seq;
  raptor_sequence_push(yyval.seq, rasqal_new_variable_literal(yyvsp[0].variable));
}
    break;

  case 45:
#line 624 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-1].seq;
  raptor_sequence_push(yyval.seq, yyvsp[0].literal);
}
    break;

  case 46:
#line 629 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-2].seq;
  raptor_sequence_push(yyval.seq, yyvsp[0].literal);
}
    break;

  case 47:
#line 634 "./sparql_parser.y"
    {
  /* rasqal_variable* are freed from the raptor_query field variables */
  yyval.seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_literal, (raptor_sequence_print_handler*)rasqal_literal_print);
  raptor_sequence_push(yyval.seq, rasqal_new_variable_literal(yyvsp[0].variable));
}
    break;

  case 48:
#line 640 "./sparql_parser.y"
    {
  yyval.seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_literal, (raptor_sequence_print_handler*)rasqal_literal_print);
  raptor_sequence_push(yyval.seq, yyvsp[0].literal);
}
    break;

  case 49:
#line 648 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-1].seq;
  raptor_sequence_push(yyval.seq, yyvsp[0].variable);
}
    break;

  case 50:
#line 653 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-2].seq;
  raptor_sequence_push(yyval.seq, yyvsp[0].variable);
}
    break;

  case 51:
#line 658 "./sparql_parser.y"
    {
  /* The variables are freed from the raptor_query field variables */
  yyval.seq=raptor_new_sequence(NULL, (raptor_sequence_print_handler*)rasqal_variable_print);
  raptor_sequence_push(yyval.seq, yyvsp[0].variable);
}
    break;

  case 52:
#line 667 "./sparql_parser.y"
    {
  raptor_uri* uri=rasqal_literal_as_uri(yyvsp[0].literal);
  yyval.seq=yyvsp[-1].seq;
  if(uri)
    raptor_sequence_push(yyval.seq, raptor_uri_copy(uri));
  rasqal_free_literal(yyvsp[0].literal);
}
    break;

  case 53:
#line 675 "./sparql_parser.y"
    {
  raptor_uri* uri=rasqal_literal_as_uri(yyvsp[0].literal);
  yyval.seq=yyvsp[-2].seq;
  if(uri)
    raptor_sequence_push(yyval.seq, raptor_uri_copy(uri));
  rasqal_free_literal(yyvsp[0].literal);
}
    break;

  case 54:
#line 683 "./sparql_parser.y"
    {
  yyval.seq=raptor_new_sequence((raptor_sequence_free_handler*)raptor_free_uri, (raptor_sequence_print_handler*)raptor_sequence_print_uri);
}
    break;

  case 55:
#line 691 "./sparql_parser.y"
    {
  yyval.literal=rasqal_new_variable_literal(yyvsp[0].variable);
}
    break;

  case 56:
#line 695 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 57:
#line 702 "./sparql_parser.y"
    {
  yyval.literal=rasqal_new_variable_literal(yyvsp[0].variable);
}
    break;

  case 58:
#line 706 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 59:
#line 714 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 60:
#line 718 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 61:
#line 725 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 62:
#line 729 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 63:
#line 737 "./sparql_parser.y"
    {
  if(((rasqal_query*)rq)->base_uri)
    raptor_free_uri(((rasqal_query*)rq)->base_uri);
  ((rasqal_query*)rq)->base_uri=yyvsp[0].uri;
}
    break;

  case 64:
#line 743 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 65:
#line 751 "./sparql_parser.y"
    {
  rasqal_prefix *p=rasqal_new_prefix(yyvsp[-1].name, yyvsp[0].uri);
  yyval.seq=((rasqal_query*)rq)->prefixes;
  raptor_sequence_push(yyval.seq, p);
  rasqal_engine_declare_prefix(((rasqal_query*)rq), p);
}
    break;

  case 66:
#line 758 "./sparql_parser.y"
    {
  /* nothing to do, rq->prefixes already initialised */
}
    break;

  case 67:
#line 766 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_OR, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 68:
#line 770 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 69:
#line 779 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_AND, yyvsp[-2].expr, yyvsp[0].expr);
;
}
    break;

  case 70:
#line 784 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 71:
#line 791 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_STR_EQ, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 72:
#line 795 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_STR_NEQ, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 73:
#line 799 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_string_op_expression(RASQAL_EXPR_STR_MATCH, yyvsp[-2].expr, yyvsp[0].literal);
}
    break;

  case 74:
#line 803 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_string_op_expression(RASQAL_EXPR_STR_NMATCH, yyvsp[-2].expr, yyvsp[0].literal);
}
    break;

  case 75:
#line 807 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 76:
#line 818 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_EQ, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 77:
#line 822 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_NEQ, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 78:
#line 826 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 79:
#line 835 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_LT, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 80:
#line 839 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_GT, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 81:
#line 843 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_LE, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 82:
#line 847 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_GE, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 83:
#line 851 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 84:
#line 860 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_PLUS, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 85:
#line 864 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_MINUS, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 86:
#line 868 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 87:
#line 878 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_STAR, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 88:
#line 882 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_SLASH, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 89:
#line 886 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_2op_expression(RASQAL_EXPR_REM, yyvsp[-2].expr, yyvsp[0].expr);
}
    break;

  case 90:
#line 890 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 91:
#line 899 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 92:
#line 903 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_UMINUS, yyvsp[0].expr);
}
    break;

  case 93:
#line 907 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 94:
#line 914 "./sparql_parser.y"
    {
  rasqal_literal *l=rasqal_new_variable_literal(yyvsp[-1].variable);
  rasqal_expression *e=rasqal_new_literal_expression(l);
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_BOUND, e);
}
    break;

  case 95:
#line 920 "./sparql_parser.y"
    {
  rasqal_expression *e=rasqal_new_literal_expression(yyvsp[-1].literal);
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_STR, e);
}
    break;

  case 96:
#line 925 "./sparql_parser.y"
    {
  rasqal_expression *e=rasqal_new_literal_expression(yyvsp[-1].literal);
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_LANG, e);
}
    break;

  case 97:
#line 930 "./sparql_parser.y"
    {
  rasqal_expression *e=rasqal_new_literal_expression(yyvsp[-1].literal);
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_DATATYPE, e);
}
    break;

  case 98:
#line 935 "./sparql_parser.y"
    {
  rasqal_expression *e=rasqal_new_literal_expression(yyvsp[-1].literal);
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_ISURI, e);
}
    break;

  case 99:
#line 940 "./sparql_parser.y"
    {
  rasqal_expression *e=rasqal_new_literal_expression(yyvsp[-1].literal);
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_ISBLANK, e);
}
    break;

  case 100:
#line 945 "./sparql_parser.y"
    {
  rasqal_expression *e=rasqal_new_literal_expression(yyvsp[-1].literal);
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_ISLITERAL, e);
}
    break;

  case 101:
#line 950 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[0].expr;
}
    break;

  case 102:
#line 958 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_TILDE, yyvsp[0].expr);
}
    break;

  case 103:
#line 962 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_1op_expression(RASQAL_EXPR_BANG, yyvsp[0].expr);
}
    break;

  case 104:
#line 966 "./sparql_parser.y"
    {
  rasqal_literal *l=rasqal_new_variable_literal(yyvsp[0].variable);
  yyval.expr=rasqal_new_literal_expression(l);
}
    break;

  case 105:
#line 971 "./sparql_parser.y"
    {
  yyval.expr=rasqal_new_literal_expression(yyvsp[0].literal);
}
    break;

  case 106:
#line 975 "./sparql_parser.y"
    {
  /* FIXME - do something with the function name, args */
  raptor_free_sequence(yyvsp[-1].seq);

  yyval.expr=NULL;
}
    break;

  case 107:
#line 982 "./sparql_parser.y"
    {
  yyval.expr=yyvsp[-1].expr;
}
    break;

  case 108:
#line 993 "./sparql_parser.y"
    {
  yyval.seq=yyvsp[-1].seq;
  raptor_sequence_push(yyval.seq, yyvsp[0].literal);
}
    break;

  case 109:
#line 998 "./sparql_parser.y"
    {
  yyval.seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_literal, (raptor_sequence_print_handler*)rasqal_literal_print);
}
    break;

  case 110:
#line 1006 "./sparql_parser.y"
    {
  yyval.literal=rasqal_new_uri_literal(yyvsp[0].uri);
}
    break;

  case 111:
#line 1010 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 112:
#line 1014 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 113:
#line 1018 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 114:
#line 1022 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 115:
#line 1026 "./sparql_parser.y"
    {
  yyval.literal=yyvsp[0].literal;
}
    break;

  case 116:
#line 1029 "./sparql_parser.y"
    {
  yyval.literal=rasqal_new_simple_literal(RASQAL_LITERAL_QNAME, yyvsp[0].name);
  if(rasqal_literal_expand_qname((rasqal_query*)rq, yyval.literal)) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", yyvsp[0].name);
    rasqal_free_literal(yyval.literal);
    yyval.literal=NULL;
  }
}
    break;

  case 117:
#line 1048 "./sparql_parser.y"
    {
  yyval.literal=rasqal_new_uri_literal(yyvsp[0].uri);
}
    break;

  case 118:
#line 1052 "./sparql_parser.y"
    {
  yyval.literal=rasqal_new_simple_literal(RASQAL_LITERAL_QNAME, yyvsp[0].name);
  if(rasqal_literal_expand_qname((rasqal_query*)rq, yyval.literal)) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", yyvsp[0].name);
    rasqal_free_literal(yyval.literal);
    yyval.literal=NULL;
  }
}
    break;

  case 119:
#line 1071 "./sparql_parser.y"
    {
  yyval.variable=rasqal_new_variable((rasqal_query*)rq, yyvsp[0].name, NULL);
}
    break;

  case 120:
#line 1075 "./sparql_parser.y"
    {
  yyval.variable=rasqal_new_variable((rasqal_query*)rq, yyvsp[0].name, NULL);
}
    break;

  case 121:
#line 1083 "./sparql_parser.y"
    {
  yyval.literal=rasqal_new_simple_literal(RASQAL_LITERAL_BLANK, yyvsp[0].name);
}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2430 "sparql_parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1089 "./sparql_parser.y"



/* Support functions */


/* This is declared in sparql_lexer.h but never used, so we always get
 * a warning unless this dummy code is here.  Used once below in an error case.
 */
static int yy_init_globals (yyscan_t yyscanner ) { return 0; };



/**
 * rasqal_sparql_query_engine_init - Initialise the SPARQL query engine
 *
 * Return value: non 0 on failure
 **/
static int
rasqal_sparql_query_engine_init(rasqal_query* rdf_query, const char *name) {
  /* rasqal_sparql_query_engine* sparql=(rasqal_sparql_query_engine*)rdf_query->context; */

  /* Initialise rdf, rdfs, owl and xsd prefixes and namespaces */
  raptor_namespaces_start_namespace_full(rdf_query->namespaces, 
                                         (const unsigned char*)"rdf",
                                         (const unsigned char*)RAPTOR_RDF_MS_URI,0);
  raptor_namespaces_start_namespace_full(rdf_query->namespaces, 
                                         (const unsigned char*)"rdfs", 
                                         (const unsigned char*)RAPTOR_RDF_SCHEMA_URI,0);
  raptor_namespaces_start_namespace_full(rdf_query->namespaces,
                                         (const unsigned char*)"xsd",
                                         (const unsigned char*)RAPTOR_XMLSCHEMA_DATATYPES_URI, 0);
  raptor_namespaces_start_namespace_full(rdf_query->namespaces,
                                         (const unsigned char*)"owl",
                                         (const unsigned char*)RAPTOR_OWL_URI, 0);

  return 0;
}


/**
 * rasqal_sparql_query_engine_terminate - Free the SPARQL query engine
 *
 * Return value: non 0 on failure
 **/
static void
rasqal_sparql_query_engine_terminate(rasqal_query* rdf_query) {
  rasqal_sparql_query_engine* sparql=(rasqal_sparql_query_engine*)rdf_query->context;

  if(sparql->scanner_set) {
    sparql_lexer_lex_destroy(sparql->scanner);
    sparql->scanner_set=0;
  }

}


static int
rasqal_sparql_query_engine_prepare(rasqal_query* rdf_query) {
  /* rasqal_sparql_query_engine* sparql=(rasqal_sparql_query_engine*)rdf_query->context; */
  int rc;
  
  if(!rdf_query->query_string)
    return 1;
  
  rc=sparql_parse(rdf_query, rdf_query->query_string);
  if(rc)
    return rc;

  return rasqal_engine_prepare(rdf_query);
}


static int
rasqal_sparql_query_engine_execute(rasqal_query* rdf_query) 
{
  /* rasqal_sparql_query_engine* sparql=(rasqal_sparql_query_engine*)rdf_query->context; */
  
  /* nothing needed here */
  return 0;
}


static int
sparql_parse(rasqal_query* rq, const unsigned char *string) {
  rasqal_sparql_query_engine* rqe=(rasqal_sparql_query_engine*)rq->context;
  raptor_locator *locator=&rq->locator;
  char *buf=NULL;
  size_t len;
  void *buffer;

  if(!string || !*string)
    return yy_init_globals(NULL); /* 0 but a way to use yy_init_globals */

  locator->line=1;
  locator->column= -1; /* No column info */
  locator->byte= -1; /* No bytes info */

#if RASQAL_DEBUG > 2
  sparql_parser_debug=1;
#endif

  rqe->lineno=1;

  sparql_lexer_lex_init(&rqe->scanner);
  rqe->scanner_set=1;

  sparql_lexer_set_extra(((rasqal_query*)rq), rqe->scanner);

  /* This
   *   buffer= sparql_lexer__scan_string((const char*)string, rqe->scanner);
   * is replaced by the code below.  
   * 
   * The extra space appended to the buffer is the least-pain
   * workaround to the lexer crashing by reading EOF twice in
   * sparql_copy_regex_token; at least as far as I can diagnose.  The
   * fix here costs little to add as the above function does
   * something very similar to this anyway.
   */
  len= strlen((const char*)string);
  buf= (char *)RASQAL_MALLOC(cstring, len+3);
  strncpy(buf, (const char*)string, len);
  buf[len]= ' ';
  buf[len+1]= buf[len+2]='\0'; /* YY_END_OF_BUFFER_CHAR; */
  buffer= sparql_lexer__scan_buffer(buf, len+3, rqe->scanner);

  sparql_parser_parse(rq);

  if(buf)
    RASQAL_FREE(cstring, buf);

  sparql_lexer_lex_destroy(rqe->scanner);
  rqe->scanner_set=0;

  /* Parsing failed */
  if(rq->failed)
    return 1;
  
  /* FIXME - should check remaining query parts  */
  if(rasqal_engine_sequence_has_qname(rq->triples) ||
     rasqal_engine_sequence_has_qname(rq->constructs) ||
     rasqal_engine_constraints_has_qname(rq)) {
    sparql_query_error(rq, "SPARQL query has unexpanded QNames");
    return 1;
  }

  return 0;
}


static void
sparql_query_error(rasqal_query *rq, const char *msg) {
  rasqal_sparql_query_engine* rqe=(rasqal_sparql_query_engine*)rq->context;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  rasqal_query_error(rq, "%s", msg);
}


static void
sparql_query_error_full(rasqal_query *rq, const char *message, ...) {
  va_list arguments;
  rasqal_sparql_query_engine* rqe=(rasqal_sparql_query_engine*)rq->context;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);

  rasqal_query_error_varargs(rq, message, arguments);

  va_end(arguments);
}


int
sparql_syntax_error(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_engine *rqe=(rasqal_sparql_query_engine*)rq->context;
  va_list arguments;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rp->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rasqal_query_error_varargs(rq, message, arguments);
  va_end(arguments);

   return (0);
}


int
sparql_syntax_warning(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_engine *rqe=(rasqal_sparql_query_engine*)rq->context;
  va_list arguments;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rasqal_query_warning_varargs(rq, message, arguments);
  va_end(arguments);

   return (0);
}


static void
rasqal_sparql_query_engine_register_factory(rasqal_query_engine_factory *factory)
{
  factory->context_length = sizeof(rasqal_sparql_query_engine);

  factory->init      = rasqal_sparql_query_engine_init;
  factory->terminate = rasqal_sparql_query_engine_terminate;
  factory->prepare   = rasqal_sparql_query_engine_prepare;
  factory->execute   = rasqal_sparql_query_engine_execute;
}


void
rasqal_init_query_engine_sparql(void) {
  rasqal_query_engine_register_factory("sparql", 
                                       "SPARQL W3C DAWG RDF Query Language",
                                       NULL,
                                       (const unsigned char*)"http://www.w3.org/TR/rdf-sparql-query/",
                                       &rasqal_sparql_query_engine_register_factory);
}



#ifdef STANDALONE
#include <stdio.h>
#include <locale.h>

#define SPARQL_FILE_BUF_SIZE 2048

int
main(int argc, char *argv[]) 
{
  const char *program=rasqal_basename(argv[0]);
  char query_string[SPARQL_FILE_BUF_SIZE];
  rasqal_query *query;
  FILE *fh;
  int rc;
  char *filename=NULL;
  unsigned char *uri_string;

#if RASQAL_DEBUG > 2
  sparql_parser_debug=1;
#endif

  if(argc > 1) {
    filename=argv[1];
    fh = fopen(argv[1], "r");
    if(!fh) {
      fprintf(stderr, "%s: Cannot open file %s - %s\n", program, filename,
              strerror(errno));
      exit(1);
    }
  } else {
    filename="<stdin>";
    fh = stdin;
  }

  memset(query_string, 0, SPARQL_FILE_BUF_SIZE);
  fread(query_string, SPARQL_FILE_BUF_SIZE, 1, fh);
  
  if(argc>1)
    fclose(fh);

  rasqal_init();

  query=rasqal_new_query("sparql", NULL);

  uri_string=raptor_uri_filename_to_uri_string(filename);
  query->base_uri=raptor_new_uri(uri_string);

  rc=sparql_parse(query, (const unsigned char*)query_string);

  rasqal_query_print(query, stdout);

  rasqal_free_query(query);

  raptor_free_memory(uri_string);

  rasqal_finish();

  return rc;
}
#endif

